<template>
  <close-content v-show="loadingEvents || events.data.length > 0">
    <template #title>
      {{
        $gettext('Events nearby %{position}', { position: userLocation.name })
      }}
    </template>
    <template #content>
      <skeleton-event-result
        v-for="i in [...Array(6).keys()]"
        class="scroll-ml-6 snap-center shrink-0 w-[18rem] my-4"
        :key="i"
        v-show="loadingEvents"
      />
      <event-result
        class="scroll-ml-6 snap-center shrink-0 first:pl-8 last:pr-8 w-[18rem]"
        v-for="event in events.data"
        :key="event.id"
        :event="event"
        view-mode="column"
        :has-border="true"
        :minimal="true"
      />
      <more-content
        v-if="userLocation.name"
        :to="{
          name: 'SEARCH',
          query: {
            locationName: userLocation.name,
            lat: userLocation.lat,
            lon: userLocation.lon,
            contentType: 'EVENTS',
            distance: `${distance}_km`,
          },
        }"
        :picture="userLocation.picture"
      >
        {{
          $gettext('View more events around %{position}', {
            position: userLocation.name,
          })
        }}
      </more-content>
    </template>
  </close-content>
</template>

<script lang="ts" setup>
  import { buildEventSearchQuery } from '../../query/buildQuery'
  import { useGettext } from 'vue3-gettext'
  import { searchEvents } from '../../shared/search'
  import { computed, inject, reactive, ref, watchEffect } from 'vue'
  import { ResultList } from '../../../../server/types/search-query/common-search.model'
  import { EnhancedEvent } from '../../../../server/types/event.model'
  import EventResult from '../../components/result/EventResult.vue'
  import { Locale } from 'date-fns'
  import SkeletonEventResult from '../result/SkeletonEventResult.vue'
  import { LocationType } from '../../../../shared/user-location.model'
  import MoreContent from './MoreContent.vue'
  import CloseContent from './CloseContent.vue'
  import { closest } from '@/shared/utils'

  const { $gettext } = useGettext()

  const dateFnsLocale = inject<Locale>('dateFnsLocale')

  const { userLocation } = inject<{
    userLocation: LocationType
  }>('userLocation')

  const events = reactive<ResultList<EnhancedEvent>>({
    total: 0,
    data: [],
  })

  const loadingEvents = ref(true)

  const distance = computed(() => {
    return closest(userLocation.accuracy, [5, 10, 25, 50, 100, 150])
  })

  watchEffect(async () => {
    const query = buildEventSearchQuery(
      {
        locationData: userLocation,
        page: 1,
        resultsPerEventsPage: 5,
        distance: `${distance.value}_km`,
        eventStartDateRange: 'future',
        locale: dateFnsLocale,
        sort: 'startTime',
      },
      $gettext
    )

    const fetchedEvents = await searchEvents(query)
    events.total = fetchedEvents.total
    events.data = fetchedEvents.data
    loadingEvents.value = false
  })
</script>
